// JpegTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "JpegTest.h"
#include "JpegTestDlg.h"
#include "JpegLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJpegTestDlg dialog
void BrowseFile(CEdit &Edit, BOOL bOpenFileDialog, DWORD dwFlags, UINT nFilterID)
{
	// TODO: Add your control notification handler code here
	CString strFileName;

	Edit.GetWindowText(strFileName);

	CFileDialog	FileDialog(bOpenFileDialog, NULL, (LPCTSTR)strFileName, dwFlags, CString((LPCSTR)nFilterID));

	if (FileDialog.DoModal() == IDOK)	{ 
		strFileName = FileDialog.GetPathName();
		Edit.SetWindowText(strFileName);
	}
}

CJpegTestDlg::CJpegTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJpegTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJpegTestDlg)
	m_strFile = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CJpegTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJpegTestDlg)
	DDX_Control(pDX, IDC_FILE_EDIT, m_FileEdit);
	DDX_Text(pDX, IDC_FILE_EDIT, m_strFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJpegTestDlg, CDialog)
	//{{AFX_MSG_MAP(CJpegTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MORE_BUTTON, OnMoreButton)
	ON_BN_CLICKED(IDC_SHOW_BUTTON, OnShowButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJpegTestDlg message handlers

BOOL CJpegTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJpegTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJpegTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJpegTestDlg::OnMoreButton() 
{
	// TODO: Add your control notification handler code here
	BrowseFile(m_FileEdit, TRUE, OFN_FILEMUSTEXIST, IDS_JPEG_FILTER);
}

void CJpegTestDlg::OnShowButton() 
{
	// TODO: Add your control notification handler code here
	HBITMAP hBitmap;

	UpdateData();
	hBitmap = LoadJPEG((LPSTR)(LPCSTR)m_strFile);
	if (hBitmap)	((CStatic *)GetDlgItem(IDC_JPEGIMAGE))->SetBitmap(hBitmap);
}
